## ignition-math 6.4.0+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-math6 VERSION 6.4.0)

#============================================================================
# Find ignition-cmake
#============================================================================
# If you get an error at this line, you need to install ignition-cmake
find_package(ignition-cmake2 2.0.0 REQUIRED)

#============================================================================
# Configure the project
#============================================================================
set (c++standard 17)
ign_configure_project()

#============================================================================
# Set project-specific options
#============================================================================

# ignition-math currently has no options that are unique to it


#============================================================================
# Search for project-specific dependencies
#============================================================================

#--------------------------------------
# Find eigen3
ign_find_package(
  EIGEN3
  REQUIRED_BY eigen3
  PRETTY eigen3
  PURPOSE "Provide conversions to eigen3 types")

########################################
# Include swig
find_package(SWIG QUIET)
if (NOT SWIG_FOUND)
  IGN_BUILD_WARNING("Swig is missing: Language interfaces are disabled.")
  message (STATUS "Searching for swig - not found.")
else()
  message (STATUS "Searching for swig - found.")
endif()

# Include other languages if swig was found
if (SWIG_FOUND)
  ########################################
  # Include ruby
  find_package(Ruby 1.9 QUIET)
  if (NOT RUBY_FOUND)
    IGN_BUILD_WARNING("Ruby is missing: Install ruby-dev to enable ruby interface to ignition math.")
    message (STATUS "Searching for Ruby - not found.")
  else()
    message (STATUS "Searching for Ruby - found.")
  endif()
endif()

#============================================================================
# Configure the build
#============================================================================
ign_configure_build(QUIT_IF_BUILD_ERRORS
  COMPONENTS eigen3)


#============================================================================
# Create package information
#============================================================================
ign_create_packages()

#============================================================================
# Configure documentation
#============================================================================
configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)

ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md")

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

# Find the Ignition-Math library
set(IGN_MATH_VER 6)
find_package(ignition-math${IGN_MATH_VER} REQUIRED)

add_executable(vector2_example vector2_example.cc)
target_link_libraries(vector2_example ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})

add_executable(triangle_example triangle_example.cc)
target_link_libraries(triangle_example ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})

add_executable(quaternion_to_euler quaternion_to_euler.cc)
target_link_libraries(quaternion_to_euler ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})

add_executable(quaternion_from_euler quaternion_from_euler.cc)
target_link_libraries(quaternion_from_euler ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})

add_executable(graph_example graph_example.cc)
target_link_libraries(graph_example ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})

=== src/CMakeLists.txt ===

# Collect source files into the "sources" variable and unit test files into the
# "gtest_sources" variable
ign_get_libsources_and_unittests(sources gtest_sources)

# Create the library target
ign_create_core_library(SOURCES ${sources} CXX_STANDARD ${c++standard})

# Build the unit tests
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources})

# graph namespace
add_subdirectory(graph)

#################################################
# Setup swig
if (SWIG_FOUND)
  include(${SWIG_USE_FILE})
  set(CMAKE_SWIG_FLAGS "")

  include_directories(${PROJECT_SOURCE_DIR}/include)

  set(swig_files
    ruby
    Angle
    Vector2
    Vector3)
endif()

#################################################
# Create and install Ruby interfaces
# Example usage
# $ export RUBYLIB=/usr/local/lib/ruby
# $ ruby -e "require 'ignition/math'; a = Ignition::Math::Angle.new(20); puts a.Degree()"
if (RUBY_FOUND)
  include_directories(${RUBY_INCLUDE_DIRS})

  foreach (swig_file ${swig_files})
    # Assuming that each swig file has a test
    list(APPEND ruby_tests ${swig_file}_TEST)

    # Generate the list if .i files
    list(APPEND swig_i_files ${swig_file}.i)

    # Removing warning from auto-generated files.
    set_source_files_properties(${swig_file}RUBY_wrap.cxx
      PROPERTIES COMPILE_FLAGS "-w")
  endforeach()

  # Turn on c++
  set_source_files_properties(${swig_i_files} PROPERTIES CPLUSPLUS ON)

  # Create the ruby library

  if(CMAKE_VERSION VERSION_GREATER 3.8.0)
    SWIG_ADD_LIBRARY(math LANGUAGE ruby SOURCES ruby.i ${swig_i_files} ${sources})
  else()
    SWIG_ADD_MODULE(math ruby ruby.i ${swig_i_files} ${sources})
  endif()

  SWIG_LINK_LIBRARIES(math ${RUBY_LIBRARY})
  target_compile_features(math PUBLIC ${IGN_CXX_${c++standard}_FEATURES})
  install(TARGETS math DESTINATION ${IGN_LIB_INSTALL_DIR}/ruby/ignition)

  # Add the ruby tests
  foreach (test ${ruby_tests})
    add_test(NAME ${test}.rb COMMAND
      ruby -I${CMAKE_BINARY_DIR}/lib ${CMAKE_SOURCE_DIR}/src/${test}.rb
   	  --gtest_output=xml:${CMAKE_BINARY_DIR}/test_results/${test}rb.xml)
  endforeach()
endif()

=== test/CMakeLists.txt ===
include_directories (
  ${PROJECT_SOURCE_DIR}/test/gtest/include
  ${PROJECT_SOURCE_DIR}/test/gtest
  ${PROJECT_SOURCE_DIR}/test
  ${CMAKE_BINARY_DIR}/include
)

configure_file (test_config.h.in ${PROJECT_BINARY_DIR}/test_config.h)

# Build gtest
add_library(gtest STATIC gtest/src/gtest-all.cc)
add_library(gtest_main STATIC gtest/src/gtest_main.cc)
target_link_libraries(gtest_main gtest)
set_property(TARGET gtest_main PROPERTY CXX_STANDARD ${c++standard})
set_property(TARGET gtest PROPERTY CXX_STANDARD ${c++standard})
set(GTEST_LIBRARY "${PROJECT_BINARY_DIR}/test/libgtest.a")
set(GTEST_MAIN_LIBRARY "${PROJECT_BINARY_DIR}/test/libgtest_main.a")

execute_process(COMMAND cmake -E remove_directory ${CMAKE_BINARY_DIR}/test_results)
execute_process(COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/test_results)
include_directories(${GTEST_INCLUDE_DIRS})

add_subdirectory(integration)
add_subdirectory(performance)
add_subdirectory(regression)

=== test/integration/CMakeLists.txt ===
set(TEST_TYPE "INTEGRATION")

set(tests
)

link_directories(${PROJECT_BINARY_DIR}/test)

# Test symbols having the right name on linux only
if (UNIX AND NOT APPLE)
  configure_file(all_symbols_have_version.bash.in ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash @ONLY)
  add_test(NAME INTEGRATION_versioned_symbols
    COMMAND bash ${CMAKE_CURRENT_BINARY_DIR}/all_symbols_have_version.bash $<TARGET_FILE:${PROJECT_LIBRARY_TARGET_NAME}>)
endif()

ign_build_tests(TYPE INTEGRATION SOURCES ${tests})

=== debian/changelog ===
ignition-math (6.4.0+ds-16) unstable; urgency=medium

  * Use string.find to fix Pose_TEST

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 17 Sep 2020 13:07:41 +0000

ignition-math (6.4.0+ds-15) unstable; urgency=medium

  * Proper __ppc64le__ macro key in pose_TEST

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 11 Sep 2020 16:50:10 +0000

ignition-math (6.4.0+ds-14) unstable; urgency=medium

  * Need to include ppc64 in the patch

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 11 Sep 2020 09:46:32 +0000

ignition-math (6.4.0+ds-13) unstable; urgency=medium

  * Update pose_TEST patch to fix problems with previous version

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 10 Sep 2020 22:07:38 +0000

ignition-math (6.4.0+ds-12) unstable; urgency=medium

  * Modify Pose_TEST for trying to fix test in different arches

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 09 Sep 2020 16:15:20 +0000

ignition-math (6.4.0+ds-11) unstable; urgency=medium

  * Include tag.xml in -dev package

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 09 Sep 2020 09:16:30 +0000

ignition-math (6.4.0+ds-10) unstable; urgency=medium

  * Add patch to fix problems in different arches realated to Pose test
    (Closes: #969364)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 08 Sep 2020 14:17:02 +0000

ignition-math (6.4.0+ds-9) unstable; urgency=medium

  * Add patch to solve compilation problems with std:limits
    (Closes: #966884)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sat, 29 Aug 2020 10:33:10 +0000

ignition-math (6.4.0+ds-8) unstable; urgency=medium

  * Team upload.
  * Drop Doxygen tag file (includes build dir)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 19 Apr 2020 12:20:06 +0200

ignition-math (6.4.0+ds-7) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 18 Apr 2020 11:30:10 +0200

ignition-math (6.4.0+ds-6) experimental; urgency=medium

  * Team upload.
  * Update d/watch to Github

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 18 Apr 2020 11:24:21 +0200

ignition-math (6.4.0+ds-5) experimental; urgency=medium

  * Team upload.
  * Add missing dependency

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 15 Apr 2020 15:12:10 +0200

ignition-math (6.4.0+ds-4) experimental; urgency=medium

  * Team upload.
  * Version depends on ignition-cmake

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 15 Apr 2020 00:12:27 +0200

ignition-math (6.4.0+ds-3) experimental; urgency=medium

  * Team upload.
  * Update packaging

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 14 Apr 2020 20:35:31 +0200

ignition-math (6.4.0+ds-2) experimental; urgency=medium

  * Team upload.
  * Rework packaging (Closes: #956483)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 13 Apr 2020 15:59:30 +0200

ignition-math (6.4.0+ds-1) experimental; urgency=medium

  * Rename source package from ignition-math4 to drop the version name
  * Include doxygen tag file
  * Support for eigen package
  * Update copyright: add comment about excluded and update years
  * Update standards and compat
  * Get all the newer versions of math in the watch file
  * Add hardening flags
  * Change library names: unversioned for -dev and math6 for library pkg name
  * Update tests to math6
  * Removed patches merge upstream
  * New upstream version 6.4.0+ds
    (Closes: #948534)
  * Remove ruby-ronn dependency (Closes: #903287)
  * Drop python dependency (Closes: #936727)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 10 Feb 2020 20:55:33 +0000

ignition-math4 (4.0.0+dfsg1-5) unstable; urgency=medium

  * Added patch to solve problems with mips(el) and hppa in tests
    (Closes: #888220)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 03 Apr 2018 22:37:17 +0000

ignition-math4 (4.0.0+dfsg1-4) unstable; urgency=medium

  * Use ffloat-store in i386 to fix problems with floating point precision
    Patch thanks to Steve Langasek (Closes: #888219)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sat, 24 Mar 2018 13:16:33 +0000

ignition-math4 (4.0.0+dfsg1-3) unstable; urgency=medium

  * Do not set any of the SSE flags in rules file
    (Closes: #890384)
  * Move control Vcs- to salsa
  * Use https in debian copyright

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 21 Mar 2018 17:46:55 +0000

ignition-math4 (4.0.0+dfsg1-2) unstable; urgency=medium

  * Update patch for failing test in i386
  * Update to compat 11

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 27 Feb 2018 08:45:43 +0000

ignition-math4 (4.0.0+dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 4.0.0
  * Initial release (Closes: #882233)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 03 Jan 2018 00:43:21 +0100

=== debian/control ===
Source: ignition-math
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               doxygen,
               libeigen3-dev,
               libgtest-dev,
               libignition-cmake-dev (>= 2),
               ruby,
               swig
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/science-team/ignition-math
Vcs-Git: https://salsa.debian.org/science-team/ignition-math.git
Homepage: https://ignitionrobotics.org/libs/math

Package: libignition-math6-6
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Ignition Robotics Math Library - Shared library
 A small, fast, and high performance math library. This library is a
 self-contained set of classes and functions suitable for robot applications.
 .
 Ignition Robotics is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.
 .
 The package contains the shared library

Package: libignition-math-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libignition-math6-6 (= ${binary:Version}),
         libignition-cmake-dev (>= 2),
         ${misc:Depends}
Replaces: libignition-math2-dev (<< 6.0.0-1~), libignition-math4-dev (<< 6.0.0-1~)
Breaks: libignition-math2-dev (<< 6.0.0-1~), libignition-math4-dev (<< 6.0.0-1~)
Description: Ignition Robotics Math Library - Development files
 A small, fast, and high performance math library. This library is a
 self-contained set of classes and functions suitable for robot applications.
 .
 Ignition Robotics is a set of simple libraries that provide useful
 functionality to bootstrap robot applications. The included libraries
 encapsulate all the essentials, such as common math data types, console
 logging, 3D mesh management, and asynchronous message passing.
 .
 The package contains the development files

Package: libignition-math4-dev
Depends: libignition-math-dev, ${misc:Depends}
Architecture: all
Section: oldlibs
Description: transitional package
 This is a transitional package. It can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

ifeq ($(DEB_HOST_ARCH),i386)
  CXXFLAGS += -ffloat-store
endif

override_dh_auto_configure:
	dh_auto_configure -- \
                -DUSE_HOST_SSE_FLAGS:BOOL=False \
                -DUSE_IGN_RECOMMENDED_FLAGS:BOOL=False

override_dh_auto_test:
	dh_auto_test $@ --no-parallel --buildsystem=cmake

%:
	dh $@

## ignition-math 6.7.0%2Bds

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                libignition-cmake-dev (>= 2),
                ruby,
                swig
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/science-team/ignition-math
 Vcs-Git: https://salsa.debian.org/science-team/ignition-math.git
@@ -37,7 +37,6 @@
 
 Package: libignition-math-dev
 Architecture: any
-Multi-Arch: same
 Section: libdevel
 Depends: libignition-math6-6 (= ${binary:Version}),
          libignition-cmake-dev (>= 2),

## ignition-math 6.7.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-math6 VERSION 6.4.0)
+project(ignition-math6 VERSION 6.7.0)
 
 #============================================================================
 # Find ignition-cmake

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,12 @@
 # Find the Ignition-Math library
 set(IGN_MATH_VER 6)
 find_package(ignition-math${IGN_MATH_VER} REQUIRED)
+
+add_executable(angle_example angle_example.cc)
+target_link_libraries(angle_example ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})
+
+add_executable(gauss_markov_process gauss_markov_process_example.cc)
+target_link_libraries(gauss_markov_process ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})
 
 add_executable(vector2_example vector2_example.cc)
 target_link_libraries(vector2_example ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})

=== include/CMakeLists.txt ===
add_subdirectory(ignition)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -23,8 +23,11 @@
   set(swig_files
     ruby
     Angle
+    GaussMarkovProcess
+    Rand
     Vector2
-    Vector3)
+    Vector3
+    Vector4)
 endif()
 
 #################################################

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,27 @@
 execute_process(COMMAND cmake -E make_directory ${CMAKE_BINARY_DIR}/test_results)
 include_directories(${GTEST_INCLUDE_DIRS})
 
+#============================================================================
+# Do a fake install of ign-math in order to test the examples.
+#============================================================================
+set(FAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/fake/install")
+
+file(MAKE_DIRECTORY ${FAKE_INSTALL_PREFIX})
+
+include(ExternalProject)
+ExternalProject_Add(
+  FAKE_INSTALL
+
+  SOURCE_DIR "${CMAKE_SOURCE_DIR}"
+  EXCLUDE_FROM_ALL 1
+  LOG_CONFIGURE 1
+  LOG_BUILD 1
+  LOG_INSTALL 1
+  CMAKE_ARGS
+    "-DBUILD_TESTING=OFF"
+    "-DCMAKE_INSTALL_PREFIX=${FAKE_INSTALL_PREFIX}"
+)
+
 add_subdirectory(integration)
 add_subdirectory(performance)
 add_subdirectory(regression)

=== eigen3/src/CMakeLists.txt ===

ign_add_component(eigen3 INTERFACE
  GET_TARGET_NAME component)

target_link_libraries(${component} INTERFACE Eigen3::Eigen)

# Collect source files into the "sources" variable and unit test files into the
# "gtest_sources" variable
ign_get_libsources_and_unittests(sources gtest_sources)

# Build the unit tests
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources}
  LIB_DEPS ${component})

=== include/ignition/CMakeLists.txt ===
add_subdirectory(math)

=== test/integration/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,6 @@
 set(TEST_TYPE "INTEGRATION")
 
-set(tests
-)
-
-link_directories(${PROJECT_BINARY_DIR}/test)
+ign_get_sources(tests)
 
 # Test symbols having the right name on linux only
 if (UNIX AND NOT APPLE)
@@ -13,3 +10,12 @@
 endif()
 
 ign_build_tests(TYPE INTEGRATION SOURCES ${tests})
+
+if(TARGET INTEGRATION_ExamplesBuild_TEST)
+  add_dependencies(INTEGRATION_ExamplesBuild_TEST FAKE_INSTALL)
+
+  set(_env_vars)
+  list(APPEND _env_vars "CMAKE_PREFIX_PATH=${FAKE_INSTALL_PREFIX}:$ENV{CMAKE_PREFIX_PATH}")
+  set_tests_properties(INTEGRATION_ExamplesBuild_TEST PROPERTIES
+    ENVIRONMENT "${_env_vars}")
+endif()

=== include/ignition/math/CMakeLists.txt ===
# Exclude the detail directory from inclusion. The purpose is to prevent the detail/* header files from being included in math.hh. A side effect is that the detail headers are not installed. The next install line solves this problem.
ign_install_all_headers(EXCLUDE_DIRS detail)
install(DIRECTORY detail DESTINATION ${IGN_INCLUDE_INSTALL_DIR_FULL}/ignition/${IGN_DESIGNATION})

=== debian/changelog ===
ignition-math (6.7.0+ds-3) unstable; urgency=medium

  * Team upload.
  * Properly handle stream errors when reading math objects
  * Manually remove build path from installed Doxygen tag file
  * Bump Standards-Version to 4.5.1

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 26 Nov 2020 16:14:34 +0100

ignition-math (6.7.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Reintroduce pose_TEST patch that got removed by accident

 -- Timo Röhling <timo@gaussglocke.de>  Thu, 26 Nov 2020 00:44:23 +0100

ignition-math (6.7.0+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 6.7.0+ds
  * Remove Multi-Arch: same from -dev package

 -- Timo Röhling <timo@gaussglocke.de>  Wed, 25 Nov 2020 22:44:28 +0100

=== debian/rules ===
--- 
+++ 
@@ -14,5 +14,9 @@
 override_dh_auto_test:
 	dh_auto_test $@ --no-parallel --buildsystem=cmake
 
+execute_after_dh_auto_install:
+	# Manually replace build path by install location in tag file
+	sed -i -e 's#$(CURDIR)/include/#/usr/include/ignition/math6/#g;s#$(CURDIR)/eigen3/include/#/usr/include/ignition-math6/#g' debian/tmp/usr/share/ignition/ignition-math6/ignition-math6.tag.xml
+
 %:
 	dh $@

## ignition-math 6.10.0%2Bds3

=== src/CMakeLists.txt ===

# Collect source files into the "sources" variable and unit test files into the
# "gtest_sources" variable
ign_get_libsources_and_unittests(sources gtest_sources)

# Create the library target
ign_create_core_library(SOURCES ${sources} CXX_STANDARD ${c++standard})

# Build the unit tests
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources})

# graph namespace
add_subdirectory(graph)

# Bindings subdirectories
if (${pybind11_FOUND})
  add_subdirectory(python_pybind11)
endif()
add_subdirectory(ruby)

## ignition-math 6.10.0+ds3

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,26 +3,36 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-math6 VERSION 6.7.0)
+project(ignition-math6 VERSION 6.10.0)
 
 #============================================================================
 # Find ignition-cmake
 #============================================================================
 # If you get an error at this line, you need to install ignition-cmake
-find_package(ignition-cmake2 2.0.0 REQUIRED)
+find_package(ignition-cmake2 2.8.0 REQUIRED)
 
 #============================================================================
 # Configure the project
 #============================================================================
 set (c++standard 17)
-ign_configure_project()
+set (CMAKE_CXX_STANDARD 17)
+ign_configure_project(VERSION_SUFFIX)
 
 #============================================================================
 # Set project-specific options
 #============================================================================
 
-# ignition-math currently has no options that are unique to it
+option(USE_SYSTEM_PATHS_FOR_RUBY_INSTALLATION
+      "Install ruby modules in standard system paths in the system"
+      OFF)
 
+option(USE_SYSTEM_PATHS_FOR_PYTHON_INSTALLATION
+      "Install python modules in standard system paths in the system"
+      OFF)
+
+option(USE_DIST_PACKAGES_FOR_PYTHON
+      "Use dist-packages instead of site-package to install python modules"
+      OFF)
 
 #============================================================================
 # Search for project-specific dependencies
@@ -43,7 +53,7 @@
   IGN_BUILD_WARNING("Swig is missing: Language interfaces are disabled.")
   message (STATUS "Searching for swig - not found.")
 else()
-  message (STATUS "Searching for swig - found.")
+  message (STATUS "Searching for swig - found version ${SWIG_VERSION}.")
 endif()
 
 # Include other languages if swig was found
@@ -55,9 +65,34 @@
     IGN_BUILD_WARNING("Ruby is missing: Install ruby-dev to enable ruby interface to ignition math.")
     message (STATUS "Searching for Ruby - not found.")
   else()
-    message (STATUS "Searching for Ruby - found.")
+    message (STATUS "Searching for Ruby - found version ${RUBY_VERSION}.")
   endif()
 endif()
+
+########################################
+# Python bindings
+include(IgnPython)
+find_package(PythonLibs QUIET)
+if (NOT PYTHONLIBS_FOUND)
+  IGN_BUILD_WARNING("Python is missing: Python interfaces are disabled.")
+  message (STATUS "Searching for Python - not found.")
+else()
+  message (STATUS "Searching for Python - found version ${PYTHONLIBS_VERSION_STRING}.")
+
+  set(PYBIND11_PYTHON_VERSION 3)
+  find_package(pybind11 2.2 QUIET)
+
+  if (${pybind11_FOUND})
+    message (STATUS "Searching for pybind11 - found version ${pybind11_VERSION}.")
+  else()
+    IGN_BUILD_WARNING("pybind11 is missing: Python interfaces are disabled.")
+    message (STATUS "Searching for pybind11 - not found.")
+  endif()
+endif()
+
+# Location of "fake install folder" used in tests
+# Defined here at root scope so it is available for tests in src and test folders
+set(FAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/fake/install")
 
 #============================================================================
 # Configure the build

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,6 @@
 cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
+
+project(ignition-math-examples)
 
 # Find the Ignition-Math library
 set(IGN_MATH_VER 6)
@@ -6,6 +8,9 @@
 
 add_executable(angle_example angle_example.cc)
 target_link_libraries(angle_example ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})
+
+add_executable(diff_drive_odometry diff_drive_odometry.cc)
+target_link_libraries(diff_drive_odometry ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})
 
 add_executable(gauss_markov_process gauss_markov_process_example.cc)
 target_link_libraries(gauss_markov_process ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})
@@ -22,5 +27,14 @@
 add_executable(quaternion_from_euler quaternion_from_euler.cc)
 target_link_libraries(quaternion_from_euler ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})
 
+add_executable(rand_example rand_example.cc)
+target_link_libraries(rand_example ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})
+
 add_executable(graph_example graph_example.cc)
 target_link_libraries(graph_example ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})
+
+add_executable(kmeans kmeans.cc)
+target_link_libraries(kmeans ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})
+
+add_executable(color_example color_example.cc)
+target_link_libraries(color_example ignition-math${IGN_MATH_VER}::ignition-math${IGN_MATH_VER})

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
 #============================================================================
 # Do a fake install of ign-math in order to test the examples.
 #============================================================================
-set(FAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/fake/install")
+# install to FAKE_INSTALL_PREFIX defined in root CMakeLists.txt
 
 file(MAKE_DIRECTORY ${FAKE_INSTALL_PREFIX})

=== src/python_pybind11/CMakeLists.txt ===
if(WIN32 AND CMAKE_BUILD_TYPE STREQUAL "Debug")
  # pybind11 logic for setting up a debug build when both a debug and release
  # python interpreter are present in the system seems to be pretty much broken.
  # This works around the issue.
  set(PYTHON_LIBRARIES "${PYTHON_DEBUG_LIBRARIES}")
endif()

message(STATUS "Building pybind11 interfaces")
# Split from main extension and converted to pybind11
pybind11_add_module(math SHARED
  src/_ignition_math_pybind11.cc
  src/Angle.cc
  src/AxisAlignedBox.cc
  src/Color.cc
  src/DiffDriveOdometry.cc
  src/Frustum.cc
  src/GaussMarkovProcess.cc
  src/Helpers.cc
  src/Kmeans.cc
  src/Material.cc
  src/PID.cc
  src/Rand.cc
  src/RollingMean.cc
  src/RotationSpline.cc
  src/SemanticVersion.cc
  src/SignalStats.cc
  src/SphericalCoordinates.cc
  src/Spline.cc
  src/StopWatch.cc
  src/Temperature.cc
  src/Vector3Stats.cc
)

target_link_libraries(math PRIVATE
  ${PROJECT_LIBRARY_TARGET_NAME}
)

if(USE_SYSTEM_PATHS_FOR_PYTHON_INSTALLATION)
  if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
    execute_process(
      COMMAND "${PYTHON_EXECUTABLE}" -c "if True:
  from distutils import sysconfig as sc
  print(sc.get_python_lib(plat_specific=True))"
      OUTPUT_VARIABLE Python3_SITEARCH
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  else()
    # Get install variable from Python3 module
    # Python3_SITEARCH is available from 3.12 on, workaround if needed:
    find_package(Python3 COMPONENTS Interpreter)
  endif()

  if(USE_DIST_PACKAGES_FOR_PYTHON)
    string(REPLACE "site-packages" "dist-packages" IGN_PYTHON_INSTALL_PATH ${Python3_SITEARCH})
  else()
    # custom cmake command is returning dist-packages
    string(REPLACE "dist-packages" "site-packages" IGN_PYTHON_INSTALL_PATH ${Python3_SITEARCH})
  endif()
else()
  # If not a system installation, respect local paths
  set(IGN_PYTHON_INSTALL_PATH ${IGN_LIB_INSTALL_DIR}/python)
endif()

set(IGN_PYTHON_INSTALL_PATH "${IGN_PYTHON_INSTALL_PATH}/ignition")

# Set the build location and install location for a CPython extension
function(configure_build_install_location _library_name)
  # Install into test folder in build space for unit tests to import
  set_target_properties(${_library_name} PROPERTIES
    # Use generator expression to avoid prepending a build type specific directory on Windows
    LIBRARY_OUTPUT_DIRECTORY $<1:${CMAKE_CURRENT_BINARY_DIR}/test>
    RUNTIME_OUTPUT_DIRECTORY $<1:${CMAKE_CURRENT_BINARY_DIR}/test>)

  # Install library for actual use
  install(TARGETS ${_library_name}
    DESTINATION "${IGN_PYTHON_INSTALL_PATH}/"
  )
endfunction()

configure_build_install_location(math)

if (BUILD_TESTING)
  # Add the Python tests
  set(python_tests
    Angle_TEST
    AxisAlignedBox_TEST
    Box_TEST
    Color_TEST
    Cylinder_TEST
    DiffDriveOdometry_TEST
    Filter_TEST
    Frustum_TEST
    GaussMarkovProcess_TEST
    Helpers_TEST
    Inertial_TEST
    Kmeans_TEST
    Line2_TEST
    Line3_TEST
    MassMatrix3_TEST
    Material_TEST
    Matrix3_TEST
    Matrix4_TEST
    MovingWindowFilter_TEST
    OrientedBox_TEST
    PID_TEST
    Plane_TEST
    Pose3_TEST
    Quaternion_TEST
    Rand_TEST
    RollingMean_TEST
    RotationSpline_TEST
    SemanticVersion_TEST
    SignalStats_TEST
    Sphere_TEST
    SphericalCoordinates_TEST
    Spline_TEST
    StopWatch_TEST
    Temperature_TEST
    Triangle3_TEST
    Triangle_TEST
    Vector2_TEST
    Vector3_TEST
    Vector3Stats_TEST
    Vector4_TEST
  )

  foreach (test ${python_tests})
    add_test(NAME ${test}.py COMMAND
      "${PYTHON_EXECUTABLE}" "${CMAKE_SOURCE_DIR}/src/python_pybind11/test/${test}.py")

    set(_env_vars)
    list(APPEND _env_vars "PYTHONPATH=${FAKE_INSTALL_PREFIX}/lib/python/")
    list(APPEND _env_vars "LD_LIBRARY_PATH=${FAKE_INSTALL_PREFIX}/lib:$ENV{LD_LIBRARY_PATH}")
    set_tests_properties(${test}.py PROPERTIES
      ENVIRONMENT "${_env_vars}")
  endforeach()

endif()

=== eigen3/include/ignition/math/CMakeLists.txt ===

ign_install_all_headers(COMPONENT eigen3)

=== debian/changelog ===
ignition-math (6.10.0+ds3-7) unstable; urgency=medium

  [ janitor-bot ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Jose Luis Rivero ]
  * Ignore integration tests when excluding FAKE

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 24 Feb 2022 15:30:14 +0000

ignition-math (6.10.0+ds3-6) unstable; urgency=medium

  * Exclude tests depending on FAKE_INSTALL in arm patches

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 23 Feb 2022 23:25:02 +0000

ignition-math (6.10.0+ds3-5) unstable; urgency=medium

  * Update patch to exclude FAKE install test in arm*
  * Do not generate python bindings in mipsel and sh4

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 23 Feb 2022 17:58:59 +0000

ignition-math (6.10.0+ds3-4) unstable; urgency=medium

  * Use DEB_BUILD_OPTIONS to set parallel=1 on non x32 arches

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Tue, 22 Feb 2022 11:13:14 +0000

ignition-math (6.10.0+ds3-3) unstable; urgency=medium

  * Fix logic in Makefile for limiting memory in exotic arches
    (Closes: #1005947)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 21 Feb 2022 18:45:40 +0000

ignition-math (6.10.0+ds3-2) unstable; urgency=medium

  * Use no-parallel for non x32/x64 arches
    Python bindings seems to have rised the memory usage to limits that killed
    arches different than x32/x64,

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 18 Feb 2022 21:11:45 +0000

ignition-math (6.10.0+ds3-1) unstable; urgency=medium

  * New upstream version 6.10.0+ds3
    (Previous ds2 had problems with cleaning ignores files)
  * Fix spelling error
  * Add patch to reduce memory consumption in FAKE examples install
    (Should help with #1005947)

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Fri, 18 Feb 2022 14:33:52 +0000

ignition-math (6.10.0+ds2-1) unstable; urgency=medium

  * New upstream version 6.10.0+ds2
  * Remove win_direct.h and update copyright metadata
  * Support for python bindings
  * Support for ruby bindings
  * Bump standards to 4.6.0. No change.
  * Remove ancient transitional packages
  * Patches to fix i386 build
  * Update copyright

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 09 Feb 2022 15:30:29 +0000

ignition-math (6.9.2+ds-1) unstable; urgency=medium

  * New upstream version 6.9.2+ds
  * Rediff patches
  * Update copyright

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 05 Jan 2022 20:27:51 +0000

ignition-math (6.8.0+ds-2) unstable; urgency=medium

  * Move 6.8.0 to unstable

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 23 Aug 2021 17:32:51 +0000

ignition-math (6.8.0+ds-1) experimental; urgency=medium

  * Include new Excluded files in copyright
  * New upstream version 6.8.0+ds
  * Remove patch merged upstream

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 03 Jun 2021 16:51:08 +0000

=== debian/control ===
--- 
+++ 
@@ -5,14 +5,18 @@
 Priority: optional
 Build-Depends: cmake,
                debhelper-compat (= 13),
+               dh-sequence-python3,
                doxygen,
                libeigen3-dev,
                libgtest-dev,
                libignition-cmake-dev (>= 2),
-               ruby,
+               python3-dev,
+               python3-pybind11 [!mipsel !sh4],
+               ruby-all-dev,
                swig
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
+XS-Ruby-Versions: all
 Vcs-Browser: https://salsa.debian.org/science-team/ignition-math
 Vcs-Git: https://salsa.debian.org/science-team/ignition-math.git
 Homepage: https://ignitionrobotics.org/libs/math
@@ -41,8 +45,6 @@
 Depends: libignition-math6-6 (= ${binary:Version}),
          libignition-cmake-dev (>= 2),
          ${misc:Depends}
-Replaces: libignition-math2-dev (<< 6.0.0-1~), libignition-math4-dev (<< 6.0.0-1~)
-Breaks: libignition-math2-dev (<< 6.0.0-1~), libignition-math4-dev (<< 6.0.0-1~)
 Description: Ignition Robotics Math Library - Development files
  A small, fast, and high performance math library. This library is a
  self-contained set of classes and functions suitable for robot applications.
@@ -54,9 +56,40 @@
  .
  The package contains the development files
 
-Package: libignition-math4-dev
-Depends: libignition-math-dev, ${misc:Depends}
-Architecture: all
-Section: oldlibs
-Description: transitional package
- This is a transitional package. It can safely be removed.
+Package: python3-ignition-math
+# Too high memory consumption for mipsel in python bindings generation
+# Architecture: any [!mipsel !sh4]
+Architecture: alpha amd64 arm64 armel armhf hppa i386 ia64 kfreebsd-amd64 kfreebsd-i386 m68k mips64el powerpc ppc64 ppc64el s390x sparc64 x32
+Section: python
+Depends: ${misc:Depends},
+         ${python3:Depends},
+         ${shlibs:Depends}
+Enhances: libignition-math6-6
+Description: Ignition Robotics Math Library - Python3 bindings
+ A small, fast, and high performance math library. This library is a
+ self-contained set of classes and functions suitable for robot applications.
+ .
+ Ignition Robotics is a set of simple libraries that provide useful
+ functionality to bootstrap robot applications. The included libraries
+ encapsulate all the essentials, such as common math data types, console
+ logging, 3D mesh management, and asynchronous message passing.
+ .
+ The package contains the Python3 bindings.
+
+Package: ruby-ignition-math
+Architecture: any
+Section: ruby
+XB-Ruby-Versions: ${ruby:Versions}
+Depends: ${misc:Depends},
+         ${ruby:Depends},
+         ${shlibs:Depends}
+Description: Ignition Robotics Math Library - Ruby bindings
+ A small, fast, and high performance math library. This library is a
+ self-contained set of classes and functions suitable for robot applications.
+ .
+ Ignition Robotics is a set of simple libraries that provide useful
+ functionality to bootstrap robot applications. The included libraries
+ encapsulate all the essentials, such as common math data types, console
+ logging, 3D mesh management, and asynchronous message passing.
+ .
+ The package contains the Ruby bindings.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
# Needed to inject correctly the python versions supported
export PYBUILD_SYSTEM=cmake
export PYBUILD_CONFIGURE_ARGS=-DPYVER={version} \
		-DUSE_HOST_SSE_FLAGS:BOOL=False \
		-DUSE_IGN_RECOMMENDED_FLAGS:BOOL=False \
		-DUSE_SYSTEM_PATHS_FOR_PYTHON_INSTALLATION=ON \
		-DUSE_DIST_PACKAGES_FOR_PYTHON=ON \
		-DUSE_SYSTEM_PATHS_FOR_RUBY_INSTALLATION=ON

# The build consumes high ammounts of RAM, only x32/x64 arches seems able to
# deal with it. There is a lintian warning about using DEB_BUILD_OPTIONS but
# I did not find a better way. Patches are welcome.
ifeq (,$(filter $(DEB_HOST_ARCH), amd64 i386))
export DEB_BUILD_OPTIONS='parallel=1'
endif

ifeq ($(DEB_HOST_ARCH),i386)
  CXXFLAGS += -ffloat-store
endif

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_install:
	# Manually replace build path by install location in tag file
	sed -i -e 's#$(CURDIR)/include/#/usr/include/ignition/math6/#g;s#$(CURDIR)/eigen3/include/#/usr/include/ignition-math6/#g' debian/tmp/usr/share/ignition/ignition-math6/ignition-math6.tag.xml

=== debian/tests/control ===
Tests: build
Depends: libignition-math-dev, pkg-config, build-essential

=== debian/watch ===
version=4
opts=filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
    dversionmangle=s/\+(debian|dfsg|ds|deb)\d*$//,repacksuffix=+ds \
    https://github.com/ignitionrobotics/ign-math/tags \
		(?:.*?/)@PACKAGE@.*_(\d[\d.]*)\.tar\.gz
